#ifndef _VECTOR3_H
#define _VECTOR3_H

#include <iostream>
#include <cmath>

using namespace std;

struct Vector3
{
   double x;
   double y;
   double z;
   Vector3( double ax=0, double ay=0, double az=0 );
   double abs2() const {  return x*x + y*y + z*z;  }
   double abs() const {  return sqrt( abs2() );  }
   Vector3 operator-() const {  return Vector3( -x, -y, -z );  }
   Vector3& operator+=( const Vector3& rhs );
   Vector3& operator-=( const Vector3& rhs );
   Vector3& operator*=( double rhs );
}; // Vector3

bool operator==( const Vector3& lhs, const Vector3& rhs );
bool operator!=( const Vector3& lhs, const Vector3& rhs );
Vector3 operator+( const Vector3& lhs, const Vector3& rhs );
Vector3 operator-( const Vector3& lhs, const Vector3& rhs );
Vector3 operator*( double lhs, const Vector3& rhs );
Vector3 operator*( const Vector3& lhs, double rhs );
double operator*( const Vector3& lhs, const Vector3& rhs );
Vector3 operator^( const Vector3& lhs, const Vector3& rhs );
ostream& operator<<( ostream& tout, const Vector3& rhs );
        
#endif // _VECTOR3_H
